/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989-1992 Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

#ident	"$Revision: 3.11 $"

/*
 * The callout structure is for a routine arranging
 * to be called by the clock interrupt
 * (clock.c) with a specified argument,
 * in a specified amount of time.
 * Used, for example, to time tab delays on typewriters.
 */
union c_tid {
	toid_t c_eid;	/* entire identifier */
	struct {
		unsigned ci_cpuid : 6;	/* list entry is on -- max 64 cpus */
		unsigned ci_fast : 1;	/* on fast callout list? */
		unsigned ci_cid  : 25;	/* ID for removal */
	} c_pid; 
}; 
	

/*
 * Note: keep c_next, c_time, and c_tid at the front of this structure.
 *   we frequencly use those fields during timeout/timein/untimeout calls
 *   and putting them together will keep them in the same 16byte cache line.
 */
struct	callout {
    	__int64_t	c_time;		/* incremental time */
	struct	callout *c_next;	/* link to next entry */
	union c_tid c_tid;
	void	(*c_func)();		/* routine */
	void	*c_arg;			/* argument to routine */
	void	*c_arg1;		/* argument to routine */
	void 	*c_arg2;		/* argument to routine */
	void	*c_arg3;		/* argument to routine */
	pl_t	c_pl;			/* priority-level to call at */
};

#define c_id 	c_tid.c_eid
#define c_cid 	c_tid.c_pid.ci_cid
#define c_fast 	c_tid.c_pid.ci_fast
#define c_cpuid c_tid.c_pid.ci_cpuid

/* A couple macros for readability */
#define C_NORM	0	/* normal callout list */
#define C_FAST	1	/* fast callout list */
#define C_CLOCK 2	/* timeouts with absolute time */
