/**************************************************************************
 *									  *
 * 		 Copyright (C) 1987, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

/* cpu board specific definitions
 */

#ifndef __SYS_CPU_H__
#define __SYS_CPU_H__

#ident "$Revision: 1.23 $"

/* CPU type definitions for cputype */

#define	CPU_IP4		4	/* 12/16 Mhz R2000 uniprocessor */
#define CPU_IP5		5	/* 16 Mhz multiprocessor */
#define	CPU_IP6		6	/* 25/33 Mhz R3000 uniprocessor  */
#define CPU_IP7		7	/* 25 Mhz multiprocessor */
#define CPU_IP9		9	/* 25 Mhz singleprocessor */
#define	CPU_IP12	12	/* Indigo with 33 Mhz R3000A */
#define	CPU_IP15	15	/* 40 Mhz R3000A multiprocessor */
#define CPU_IP17	17	/* 50 Mhz R4000 uniprocessor */
#define CPU_IP19	19	/* 75 Mhz R4000 multiprocessor */
#define CPU_IP20	20	/* Indigo with 50/75 Mhz R4000 */
#define CPU_IP21	21	/* (?) MHz TFP multiprocessor */
#define CPU_IP22	22	/* Indigo2 with R4x00 */
#define CPU_IP25	25	/* R10000 multiprocessor */
#define CPU_IP26	26	/* Indigo2 with TFP */
#define CPU_IP28	28	/* Indigo2 with R10000 */
#define CPU_IP30	30	/* SpeedRacer */
#define CPU_IP32        32      /* Moosehead */

#if IP17
#include "sys/IP17.h"
#endif

#if IP19
#include "sys/EVEREST/everest.h"
#include "sys/EVEREST/IP19.h"
#endif

#if IP20
#include "sys/IP20.h"
#endif

#if IP21
#include "sys/EVEREST/everest.h"
#include "sys/EVEREST/IP21.h"
#endif

#if IP22
#include "sys/IP22.h"
#endif

#if IP25
#include "sys/EVEREST/everest.h"
#include "sys/EVEREST/IP25.h"
#endif

#if IP26
#include "sys/IP26.h"
#endif

#if IP28
#include "sys/IP22.h"			/* we use IP22 baseboard */
#endif

#if IP30
#include "sys/RACER/IP30.h"
#endif

#if IP32
#include "sys/IP32.h"
#endif

#if IPMHSIM
#include "sys/IPMHSIM.h"
#endif

#endif /* __SYS_CPU_H__ */
