/*	Copyright (c) 1990, 1991 UNIX System Laboratories, Inc.	*/
/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF     	*/
/*	UNIX System Laboratories, Inc.                     	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef	_FS_FS_SUBR_H	/* wrapper symbol for kernel use */
#define _FS_FS_SUBR_H	/* subject to change without notice */

#ifdef __cplusplus
extern "C" {
#endif

/*#ident	"@(#)uts-comm:fs/fs_subr.h	1.3"*/
#ident	"$Revision: 1.9 $"

/*
 * Utilities shared among file system implementations.
 */
struct cred;
struct pregion;
struct vnode;
struct pollhead;
struct flock;

extern int	fs_noerr();
extern int	fs_nosys();
#define	fs_nosyspoll	\
    (int(*)(struct vnode *, short, int, short *, struct pollhead **))fs_nosys
extern void	fs_noval();
extern int	fs_cmp();
extern int	fs_frlock(struct vnode *, int, struct flock *,
			  int, off_t, struct cred *);
extern int	fs_setfl();
extern int	fs_poll(struct vnode *, short, int,
			short *, struct pollhead **);
extern int	fs_vcode(struct vnode *, u_long *);
extern int	fs_pathconf();

/*
 * Compatibility with pure SVR4 fs_subr.h.
 */
#define fs_sync		fs_noerr
#define fs_rwlock	fs_noval
#define fs_rwunlock	fs_noval

/*
 * Common subroutine of conventional filesystems' VOP_MAP operation.
 */
extern int	fs_map_subr(struct vnode *, off_t, mode_t, off_t, 
			     struct pregion *, addr_t, size_t, u_int, u_int,
			     u_int, struct cred *);

extern int	fs_fmtdirent(void *, ino_t, off_t, char *);
extern int	irix5_fs_fmtdirent(void *, ino_t, off_t, char *);
#ifdef _K32U64
extern int	irix5_n32_fs_fmtdirent(void *, ino_t, off_t, char *);
#endif

#ifdef __cplusplus
}
#endif

#endif /* _FS_FS_SUBR_H */
