#ifndef __SYS_KABI_H__
#define __SYS_KABI_H__

/* kernel and drivers include only */
typedef struct kobj {
	struct kobj	*next;		/* next on list */
	short		module;		/* module name XXX each module has 
					   its own list so do I need to save 
					this*/
	short		id;		/* private to module */
	int		refcnt;			/* access count */
	char		*buf;		/* obj memory */
#ifdef DEBUG
	int		bufsiz;
#endif
} kobj_t;

typedef struct v_mapent {
        caddr_t start;
        caddr_t end;
        int     mode;   /* always map at 0? */
} v_mapent_t;

typedef struct proc_handl {
	int dummy;
} proc_handl_t;

typedef struct shaddr_handl {
	int dummy;
} shaddr_handl_t;

#define MAX_MODULES	1		/* GFX */
#define _GFX_MODULE	0		/* GFX */

#define _NULLID		0

/*
 * Macros and defines to find out the user's ABI
 * These have been moved here from proc.h so kernel modules which do
 * not include proc.h but include xlate.h, which needs these defines,
 * can compile.
 */
/* If you add new values, make sure they can fit in their field
 * in struct proc - currently at 8 bits! */
#define ABI_IRIX5	0x02		/* an IRIX5/SVR4 ABI binary */
#define ABI_IRIX5_64 	0x04		/* an IRIX5-64 bit binary */
#define ABI_IRIX5_N32 	0x08		/* an IRIX5-32 bit binary (new abi) */

#define ABI_IS(set,abi)		(((set) & (abi)) != 0)
#define ABI_IS_IRIX5(abi)	(ABI_IS(ABI_IRIX5, abi))
#define ABI_IS_IRIX5_N32(abi)	(ABI_IS(ABI_IRIX5_N32, abi))
#define ABI_IS_IRIX5_64(abi)	(ABI_IS(ABI_IRIX5_64, abi))
#define ABI_IS_64BIT(abi)	(ABI_IS(ABI_IRIX5_64, abi))
#define ABI_IS_SVR4(abi)	(ABI_IS(ABI_IRIX5|ABI_IRIX5_N32|ABI_IRIX5_64, abi))
#define ABI_HAS_8_AREGS(abi)	(ABI_IS(ABI_IRIX5_N32|ABI_IRIX5_64, abi))
#define ABI_HAS_64BIT_REGS(abi)	(ABI_IS(ABI_IRIX5_N32|ABI_IRIX5_64, abi))


extern int npprocscan(int ((*)(struct proc *, void *, int)), void *);
extern void sysinfo_outch_add(int);
extern void sysinfo_rawch_add(int);
extern int curabi_is_irix5_64(void);
extern void force_resched(void);
extern void set_user_error(int);
extern int get_user_error(void);
extern void set_user_rval(int);
extern void force_resched(void);
extern void set_triggersave(int);
extern void cursproc_scan(int (*func)(proc_handl_t *p, void *arg), void *arg);
extern void *cursproc_buflocate(int, int);
extern void *sproc_buflocate(int, int, proc_handl_t *);
extern void *curproc_buflocate(int, int);
extern kobj_t *curproc_kobjlocate(int, int);
extern kobj_t *proc_kobjlocate(int, int, proc_handl_t *);
extern void *proc_buflocate(int, int, proc_handl_t *);
extern int cursproc_refcnt(void);
extern void proc_dupkobj(proc_handl_t *, kobj_t *);
extern kobj_t * curproc_kobjalloc(int, int);
extern void cursproc_delgfx(kobj_t *);
extern void cursproc_dupgfx(kobj_t *);
extern kobj_t *cursproc_kobjlocate(int, int);
extern void cursproc_freekobj(kobj_t *);
extern void curproc_freekobj(kobj_t *);
extern void *cursproc_bufalloc(int, int, int);
extern proc_handl_t *curproc(void);
extern void *get_cursproc_shaddr(void);
extern int proc_isgraph(proc_handl_t *);
extern void clear_graphproc(proc_handl_t *);
extern void setgfx_schedproc(proc_handl_t *);
extern void setpdvec_curproc(int);
extern void clearpdvec_curproc(int);
extern int cursproc_refcnt(void);
extern void v_invaltlb(void *);
extern int v_invaltlb_range(void *, caddr_t, int);
extern int v_pmapfree(void *);
extern void v_regdetach(void *);
extern int v_mapsegment(void *, caddr_t, unsigned, pgno_t, int, __psunsigned_t);
extern char *v_regionva(void *);
extern int v_pregscan(void (*)(void *, void *, void *), int, void *, caddr_t);
extern void *v_creatreg(int, int, caddr_t, int (*)(), void *, int, v_mapent_t *, int);
extern void *preglookup(void *, int);
extern int chk_dmabuf_attr(char *, int, int);
extern int curproc_vtop(caddr_t, int, int *, int);
extern int curproc_vtopv(caddr_t, int, int *, int, int, int);
extern char curproc_abi(void);
extern void setgfxsched_curproc(void);
extern void setgfxsched_proc(proc_handl_t *pp);
extern int processors_configured(void);
extern void cleargfxsched_curproc(void);
extern void gfx_waitc_on(void);
extern void gfx_waitc_off(void);
extern void gfx_waitf_on(void);
extern void gfx_waitf_off(void);
#ifdef R10000_SPECULATION_WAR
extern void unmaptlb_range(caddr_t, size_t);
#endif

#endif /* __SYS_KABI_H__ */
