/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989-1994 Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
#ifndef __SYS_SHAREIISTUBS_H__
#define __SYS_SHAREIISTUBS_H__
#ifdef __cplusplus
extern "C" {
#endif

#ident	"$Revision: 1.7 $"

#if _SHAREII

/*
 *	This is set when the real ShareII code is linked into the
 *	kernel.  It is set by the real SHinit(), and is never cleared
 *	in a running kernel.
 */
extern int	IsShareRunning;

struct affq_s;
struct shaddr_s;
struct vfs;
struct syssgia;

/*
 *	Prototypes for all the Share hooks called from the mainline
 *	kernel code.
 */
extern void	SHclock1sec(void);
extern void	SHinit(void);
extern void	SHmain(void);

extern void	SHexit(proc_t *);
extern void	SHpcntUP(proc_t *);
extern void	SHpcntDN(proc_t *);

extern pri_t	SHsetpri(proc_t *);
extern int	SHaffenq(proc_t *, proc_t *);
extern int	SHsortq(struct affq_s *);

extern int	SHlimitMemory(long long, int);
extern int	SHlimitShaddr(struct shaddr_s *, long long, int);
extern int	SHlimitDisk(struct vfs *, uid_t, int, int, int, int *);

extern int	SHchownAllow(void);
extern void	SHrdwr(struct vnode *, int);
extern void	SHupdate(void);
extern int	SHchownDisk(struct vfs *, uid_t, uid_t, u_long, int);
extern int	SHumask(void);

extern void	SHsyscall(void);
extern int	SHprocalloc(proc_t *);
extern void	SHprocfree(proc_t *);
extern void	SHfreeproc(proc_t *);
extern int	SHfork(void);
extern void	SHprocfork1(proc_t *, proc_t *);
extern void	SHprocfork2(proc_t *);
extern void	SHbio(void);
extern void	SHsetuid1(uid_t);
extern void	SHsetuid2(uid_t);

extern int	SHlimits(struct syssgia *, rval_t *);

extern uid_t	SHprgetpsinfo(proc_t *);

/*
 * These control the behaviour of limit check/enforce functions:
 *	SHlimitDisk()
 *	SHlimitMemory()
 *	SHlimitShaddr()
 */
#define	LI_ENFORCE	0x1
#define	LI_UPDATE	0x2

#endif	/* !_SHAREII */

#ifdef __cplusplus
}
#endif

#endif /* __SYS_SHAREIISTUBS_H__ */
