/**************************************************************************
 *									  *
 * 		 Copyright (C) 1990-1991 Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*
 * sys/usioctl.h -- structures and defines for poll-able semaphores
 */
#ifndef __USIOCTL_H__
#define __USIOCTL_H__

#ident "$Revision: 1.10 $"

#include "sys/poll.h"

#define USEMADEV	"/dev/usema"
#define USEMACLNDEV	"/dev/usemaclone"
/*
 * Ioctl commands.
 */
#define UIOC	('u' << 16 | 's' << 8)

#define UIOCATTACHSEMA	(UIOC|2)	/* attach to exising sema */
#define UIOCBLOCK	(UIOC|3)	/* block, sync, intr */
#define UIOCABLOCK	(UIOC|4)	/* block, async */
#define UIOCNOIBLOCK	(UIOC|5)	/* block, sync, intr */
#define UIOCUNBLOCK	(UIOC|6)	/* unblock sync */
#define UIOCAUNBLOCK	(UIOC|7)	/* unblock async */
#define UIOCINIT	(UIOC|8)	/* init semaphore async */
#ifdef _HIBERNATORII
#define UIOCGETSEMASTATE (UIOC|9)	/* get all sema state */

typedef struct ussemastate_s {
	int	npid;		/* Input: number of pid structs */
	int	nfilled;	/* Return: number filled */
	int 	nproc;		/* Return: number of processes */
	struct ussemapidstate_s {
		pid_t	pid;
		int	count;
	} *pidinfo;
} ussemastate_t;

typedef struct ussemapidstate_s ussemapidstate_t;

#endif /* _HIBERNATORII */

typedef struct usattach_s {
	dev_t	us_dev;		/* attach dev */
	void	*us_handle;	/* user level semaphore handle */
} usattach_t;

typedef struct irix5_usattach_s {
	__uint32_t	us_dev;		/* attach dev */
	__uint32_t	us_handle;	/* user level semaphore handle */
} irix5_usattach_t;

#endif
