/**************************************************************************
 *									  *
 * 		 Copyright (C) 1992, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

/*
 * $Revision: 1.27 $
 */

#ifndef _HOST_FCG_H_
#define _HOST_FCG_H_

#define VENICE_FCG

#ifdef IP19
#define VENICE_BOARDNAME	"REV"	/* Reality Engine - Everest */
#endif

#ifdef IP21
#define	VENICE_BOARDNAME	"RET"	/* Reality Engine - TFP */
#endif

#ifdef IP25
#define	VENICE_BOARDNAME	"RES"	/* Reality Engine - SHIVA */
#endif

/* #ifdef IP19 */
#if _PAGESZ == 4096
#define VENICE_USER_FIFO_SIZE	0x4000	/* size of fifo hardware to map */
#define VENICE_PRIV_FIFO_SIZE	0x4000	/* size of priviledged fifo for diags */
#define VENICE_USER_VFIFO_SIZE	0x4000	/* size of variable fifo to map */
#define VENICE_PRIV_VFIFO_SIZE	0x4000	/* size of priv variable fifo for diags */
#define VENICE_RDATA_SIZE	0x2000	/* size of return data area */
#define VENICE_RFLUSH_SIZE	0x1000	/* PIO readback to chase flush across bus */
#define VENICE_HOLE_1		0xb000	/* hole in space */
#define VENICE_F_REGS_SIZE	0x1000	/* size of MPG regs for diags */
#define VENICE_HOLE_2		0x7000	/* hole in space */
#define VENICE_FCG_REGS_SIZE	0x3000	/* size of MPG regs for diags */
#define VENICE_HOLE_3		0xd5000	/* hole in space */
#define VENICE_VCBUS_SIZE	0x80000	/* size of vcbus to map */
#define VENICE_VCFIFO_SIZE	0x80000	/* size of vcbus fifo to map */
#define VENICE_UBUS_SIZE	0x200000/* size of ubus to map */
#define VENICE_MAP_SIZE		(\
				VENICE_USER_FIFO_SIZE+\
				VENICE_PRIV_FIFO_SIZE+\
				VENICE_USER_VFIFO_SIZE+\
				VENICE_PRIV_VFIFO_SIZE+\
				VENICE_RDATA_SIZE+\
				VENICE_RFLUSH_SIZE\
				)
#define VENICE_DIAG_MAP_SIZE	(\
				VENICE_MAP_SIZE+\
				VENICE_HOLE_1+\
				VENICE_F_REGS_SIZE+\
				VENICE_HOLE_2+\
				VENICE_FCG_REGS_SIZE+\
				VENICE_HOLE_3+\
				VENICE_VCBUS_SIZE+\
				VENICE_VCFIFO_SIZE+\
				VENICE_UBUS_SIZE\
				)

#define VENICE_BASE_ADDR	0x002000
#define VENICE_USER_FIFO_ADDR   0x002000
#define VENICE_PRIV_FIFO_ADDR   0x006000
#define VENICE_USER_VFIFO_ADDR  0x00a000
#define VENICE_PRIV_VFIFO_ADDR  0x00e000
#define VENICE_RDATA_ADDR	0x012000
#define VENICE_RFLUSH_ADDR	0x014000
#define VENICE_F_REGS_ADDR      0x020000
#define VENICE_FCG_REGS_ADDR    0x028000
#define VENICE_VCBUS_ADDR	0x100000
#define VENICE_VCFIFO_ADDR	0x180000
#define VENICE_UBUS_ADDR	0x200000
#endif

/* #ifdef IP21 */
#if _PAGESZ == 16384
#define VENICE_USER_FIFO_SIZE	0x4000	/* size of fifo hardware to map */
#define VENICE_PRIV_FIFO_SIZE	0x4000	/* size of priviledged fifo for diags */
#define VENICE_USER_VFIFO_SIZE	0x4000	/* size of variable fifo to map */
#define VENICE_PRIV_VFIFO_SIZE	0x4000	/* size of priv variable fifo for diags */
#define VENICE_RDATA_SIZE	0x4000	/* size of return data area */
#define VENICE_RFLUSH_SIZE	0x4000	/* PIO readback to chase flush across bus */
#define VENICE_HOLE_1		0x4000	/* hole in space */
#define VENICE_F_REGS_SIZE	0x4000	/* size of MPG regs for diags */
#define VENICE_HOLE_2		0x4000	/* hole in space */
#define VENICE_FCG_REGS_SIZE	0x4000	/* size of MPG regs for diags */
#define VENICE_HOLE_3		0xd4000	/* hole in space */
#define VENICE_VCBUS_SIZE	0x80000	/* size of vcbus to map */
#define VENICE_VCFIFO_SIZE	0x80000	/* size of vcbus fifo to map */
#define VENICE_UBUS_SIZE	0x200000/* size of ubus to map */
#define VENICE_MAP_SIZE		(\
				VENICE_USER_FIFO_SIZE+\
				VENICE_PRIV_FIFO_SIZE+\
				VENICE_USER_VFIFO_SIZE+\
				VENICE_PRIV_VFIFO_SIZE+\
				VENICE_RDATA_SIZE+\
				VENICE_RFLUSH_SIZE\
				)
#define VENICE_DIAG_MAP_SIZE	(\
				VENICE_MAP_SIZE+\
				VENICE_HOLE_1+\
				VENICE_F_REGS_SIZE+\
				VENICE_HOLE_2+\
				VENICE_FCG_REGS_SIZE+\
				VENICE_HOLE_3+\
				VENICE_VCBUS_SIZE+\
				VENICE_VCFIFO_SIZE+\
				VENICE_UBUS_SIZE\
				)

#define VENICE_BASE_ADDR	0x004000    /* start at 16k */
#define VENICE_USER_FIFO_ADDR   0x004000
#define VENICE_PRIV_FIFO_ADDR   0x008000
#define VENICE_USER_VFIFO_ADDR  0x00c000
#define VENICE_PRIV_VFIFO_ADDR  0x010000
#define VENICE_RDATA_ADDR	0x014000
#define VENICE_RFLUSH_ADDR	0x018000
#define VENICE_F_REGS_ADDR      0x020000
#define VENICE_FCG_REGS_ADDR    0x028000
#define VENICE_VCBUS_ADDR	0x100000
#define VENICE_VCFIFO_ADDR	0x180000
#define VENICE_UBUS_ADDR	0x200000
#endif

/* configuration limitations */
#define VENICE_FIFO_LENGTH	4096	/* #entries in upper fifo */

#define VENICE_FIFO_HIWATER	2048	/* hardware checked hiwater */
#define VENICE_FIFO_LOWATER	1024	/* hardware checked lowater */
#define VENICE_FIFO_SOFTWATER	1500	/* software checked lowater */
#define VENICE_FIFO_SPINCNT	30	/* in terms of usec */

/* 
 * FCG registers are addressed as 32 bit words (They should have been 
 * addressed as 64 bits words, but it doesn't exist yet.)
 */

#define FCG_BOARD_ID_ADDR	    (0x01000<<1)    /* board id		    */
#define	    FCG_BOARD_ID_VALUE		0xEE180000  /* board id value	    */
#define FCG_REVISION_ID_ADDR	    (0x01001<<1)    /* chip revision addr   */
#define	    FCG_REVISION_ID_VALUE	0	    /* chip revision value  */
#define FCG_VER_RET_SEQ_BUF_ADDR    (0x01002<<1)    /* retrace sequence buf */
#define FCG_VC_FIFO_RDY_ADDR	    (0x01003<<1)    /* VC Fifo ready propag.*/
#define	    FCG_VC_FIFO_RDY_MASK	0x1
#define FCG_LOOP_BACK_ADDR	    (0x01004<<1)    /* loop back addr	    */
#define FCG_CMD_OVERLAP_ADDR	    (0x01005<<1)    /* command overlap addr */
#define FCG_FCG_TIMER_SLOT_ADDR	    (0x01006<<1)    /* FCG timer slot addr  */
#define FCG_F_TIMER_SLOT_ADDR	    (0x01007<<1)    /* F timer slot addr    */
#define FCG_PROG_FCI_ADDR	    (0x01008<<1)    /* programable FCI addr */
#define FCG_CMD_MAPPER_BASE_ADDR    (0x01100<<1)    /* command mapper base  */
#define	    FCG_CMD_MAPPER_OFFSET_POS	0+1
#define	    FCG_CMD_MAPPER_OFFSET_MASK	(0xff<<1)
#define	    FCG_CMD_MAPPER_SIZE		64	    /* 64 entries	    */
#define	    FCG_CMD_MAPPER_POS		4	    /*  		    */
#define	    FCG_CMD_MAPPER_MASK		0x1f0	    /* 5 bits		    */
#define FCG_IDMA_CNTL_ADDR	    (0x01140<<1)    /* IDMA control addr    */
#define	    FCG_IDMA_CNTL_CP_CMD_POS	    0	    /* forced CP cmd	    */
#define	    FCG_IDMA_CNTL_CP_CMD_MASK	    0x3ff
#define	    FCG_IDMA_CNTL_PASSTHRU_POS	    10	    /* enter passthru mode  */
#define	    FCG_IDMA_CNTL_PASSTHRU_MASK	    0x400
#define	    FCG_IDMA_CNTL_UNSTOPPABLE_POS   11	    /* is it OK to intr	    */
#define	    FCG_IDMA_CNTL_UNSTOPPABLE_MASK  0x800
#define FCG_ODMA_COUNT_ADDR	    (0x01200<<1)    /* ODMA word count	    */
#define	    FCG_ODMA_COUNT_MAX_POS	0	    /* Max word count	    */
#define	    FCG_ODMA_COUNT_MAX_MASK	0x7fffff
#define	    FCG_ODMA_COUNT_INTR_EN_POS	23	    /* overrun interrupt    */
#define	    FCG_ODMA_COUNT_INTR_EN_MASK	0x800000
#define FCG_PROG_INTR_DST_ADDR	    (0x01300<<1)
#define FCG_ERROR_INTR_ADDR	    (0x01310<<1)
#define FCG_FIFO_HIGH_INTR_ADDR	    (0x01311<<1)
#define FCG_FIFO_LOW_INTR_ADDR	    (0x01312<<1)
#define FCG_FIFO_OVERFLOW_INTR_ADDR (0x01313<<1)
#define FCG_VIDEO0_INTR_ADDR	    (0x01314<<1)
#define FCG_VIDEO1_INTR_ADDR	    (0x01315<<1)
#define FCG_ODMA_INTR_ADDR	    (0x01316<<1)
#define FCG_GEF_INTR_CLEAR_ADDR	    (0x01320<<1)
#define FCG_ERROR_ADDR		    (0x01330<<1)
#define	    FCG_ERROR_IDMA_POS		0
#define	    FCG_ERROR_IDMA_MASK		0x1
#define	    FCG_ERROR_PARITY_POS	1
#define	    FCG_ERROR_PARITY_MASK	0x2

#define FCG_FIFO_LOW_MARK_ADDR	    (0x01400<<1)
#define FCG_FIFO_HIGH_MARK_ADDR	    (0x01401<<1)
#define FCG_FIFO_VERY_HIGH_MARK_ADDR (0x01402<<1)
#define FCG_FIFO_COUNT_ADDR	    (0x01403<<1)
#define FCG_FIFO_READ_PTR_ADDR	    (0x01404<<1)
#define FCG_FIFO_WRITE_PTR_ADDR	    (0x01405<<1)

#define FCG_JTAG_CNTL_ADDR	    (0x01500<<1)/* jtag ctrl & upper EEPROM */
#define	    FCG_CTL_JSEL_RM0		0x00	    /* select RM 0 chain    */
#define	    FCG_CTL_JSEL_RM1		0x01	    /* select RM 1 chain    */
#define	    FCG_CTL_JSEL_RM2		0x02	    /* select RM 2 chain    */
#define	    FCG_CTL_JSEL_RM3		0x03	    /* select RM 3 chain    */
#define	    FCG_CTL_JSEL_DG		0x04	    /* select DG chain	    */
#define	    FCG_CTL_JSEL_GE		0x0d	    /* select GE chain	    */
#define	    FCG_CTL_JTAG_SHIFT1		0x10	    /* shift 1 bit not 8    */
#define	    FCG_CTL_JTAG_TESTMODE	0x20	    /* test mode	    */

#define FCG_JTAG_DATA_ADDR	    (0x01501<<1)    /* jtag shift data      */
#define FCG_JTAG_TMS_ADDR	    (0x01502<<1)    /* jtag TMS data        */
#define FCG_MISC_ADDR		    (0x01503<<1)/* board rev & jtag status  */
#define	    FCG_JTAG_READY_POS		0
#define	    FCG_JTAG_READY_MASK		0x01	    /* controller ready	    */
#define	    FCG_JTAG_TDO_POS		1
#define	    FCG_JTAG_TDO_MASK		0x02	    /* ctrler TDO bit	    */
#define	    FCG_JTAG_TB_TMS_POS		2
#define	    FCG_JTAG_TB_TMS_MASK	0x04	    /* tbus tms bit	    */
#define	    FCG_JTAG_GE_TMS_POS		3
#define	    FCG_JTAG_GE_TMS_MASK	0x08	    /* ge tms bit	    */
#define	    FCG_MISC_BD_ID_POS		4
#define	    FCG_MISC_BD_ID_MASK		0x70	    /* board revision       */
#define		FCG_MISC_BD_ID_12GES	0x7	    /* set by jumpers	    */
#define		FCG_MISC_BD_ID_10GES	0x6	    /* to determine GE	    */
#define		FCG_MISC_BD_ID_8GES	0x5	    /* count at init time   */
#define		FCG_MISC_BD_ID_6GES	0x4
#define		FCG_MISC_BD_ID_4GES	0x3
#define		FCG_MISC_BD_ID_2GES	0x2
#define		FCG_MISC_BD_ID_1GE	0x1
#define	    FCG_GPI_CABLE_ID_POS	7
#define	    FCG_GPI_CABLE_ID_MASK	0x80
#define FCG_UTIL_BASE_ADDR	    (0x180000<<1)
#define FCG_EEPROM_BASE_ADDR	    FCG_UTIL_BASE_ADDR
#define FCG_VC_BASE_ADDR	    (0x100000<<1)
#define	    FCG_VC_ADDR_POS		    (0+1)
#define	    FCG_VC_ADDR_MASK		    (0x0ffff<<1)
#define	    FCG_VC_FIFO_POS		    (17+1)
#define	    FCG_VC_FIFO_MASK		    (0x20000<<1)
#define FCG_VC_NONFIFO_BASE_ADDR    FCG_VC_BASE_ADDR
#define FCG_VC_FIFO_BASE_ADDR	    (FCG_VC_BASE_ADDR | FCG_VC_FIFO_MASK)
#define		FCG_VC_TYPE_DATA		0x0
#define		FCG_VC_TYPE_FIFO_DATA		0x1
#define		FCG_VC_TYPE_PUSH_DATA		0x2

#define FCG_CMD_MAP_ADDR_CONFIG(id)			\
    (FCG_CMD_MAPPER_BASE_ADDR |				\
    ((id << FCG_CMD_MAPPER_OFFSET_POS) & FCG_CMD_MAPPER_OFFSET_MASK))

#define FCG_VC_ADDR_CONFIG(fifo, addr)			\
    (((fifo << FCG_VC_FIFO_POS) & FCG_VC_FIFO_MASK) |	\
    ((addr << FCG_VC_ADDR_POS) & FCG_VC_ADDR_MASK))

#define FCG_STATUS_CMD_POS	0
#define FCG_STATUS_CMD_MASK	0x3ff
#define FCG_STATUS_VAR_POS	10
#define FCG_STATUS_VAR_MASK	0x400
#define FCG_STATUS_PRIV_POS	11
#define FCG_STATUS_PRIV_MASK	0x800
#define FCG_STATUS_IDMA_POS	12
#define FCG_STATUS_IDMA_MASK	0x1000
#define FCG_STATUS_PEND_POS	13
#define FCG_STATUS_PEND_MASK	0x2000

#define FCG_GEF_CNTL_ADDR	FCG_JTAG_CNTL_ADDR

/* interrupt configuration registers from above all use these bit defs */
#define FCG_INTR_VECTOR_POS	    0		/* interrupt status	    */
#define FCG_INTR_VECTOR_MASK	    0x0000007f
#define FCG_INTR_ENABLE_POS	    7		/* enable interrupt	    */
#define FCG_INTR_ENABLE_MASK	    0x00000080

#define FCG_INTR_CONFIG(vector,enable)\
	(((vector) & FCG_INTR_VECTOR_MASK) |\
	(((enable) << FCG_INTR_ENABLE_POS) & FCG_INTR_ENABLE_MASK))


/* XXX the following structures assume big endian systems, when
 * we have 64-bit compiler that supports intint, this should
 * be changed.
 */
struct cmdmapper {
	volatile int	value;
	int		pad;
};


struct fcg {
	int		pad[0x2000];
	volatile int	board_id;	/* board ID reg		(0x1000)	*/
	int		pad0[1];
	volatile int	rev_id;		/* FCG revision ID reg	(0x1001)	*/
	int		pad1[1];
	volatile int	vrsb;		/* vertical retrace sequence buffer(1002)*/
	int		pad2[1];
	volatile int	VC_fifo_rdy;	/* VC fifo ready	(0x1003)	*/
	int		pad3[1];
	volatile int	loopback;	/* FCI loopback reg	(0x1004)	*/
	int		pad4[1];
	volatile int	enb_cmd_ovlap;	/* enable FCI cmd overlap reg	(0x1005)*/
	int		pad5[1];
	volatile int	FCG_timer;	/* FCG timer slot reg	(0x1006)	*/
	int		pad6[1];
	volatile int	F_timer;	/* F timer slot reg	(0x1007)	*/
	int		pad7[1];
	volatile int	FCI_addr_hi;	/* High two bits of FCG address	(0x1008)*/
	int		pad8[1];
	int		pad9[247*2];	/* padding till we get to cmd mapper 	*/
	volatile struct cmdmapper cmdmapper[64];  /* Cmd mapper (0x1100)	*/
	volatile int	ctx_switch;	/* context switch register (0x1140)	*/
	int		pad10[1];
	int		pad11[191*2];
	volatile int	odma_wcnt;	/* Odma wd count reg 	(0x1200)	*/
	int		pad12[255*2+1];
	volatile int	intr_dst;	/* Pgm intr destination (0x1300)	*/
	int		pad13[31];
	volatile int	err_vec;	/* Error Intr vector	(0x1310)	*/
	int		pad14[1];
	volatile int	hiwater_vec;	/* Hi water Intr vector	(0x1311)	*/
	int		pad15[1];
	volatile int	lowater_vec;	/* Lo water Intr vector	(0x1312)	*/
	int		pad16[1];
	volatile int	gfxofl_vec;	/* fifo overflow Intr vector (0x1313)	*/
	int		pad17[1];
	volatile int	vint1_vec;	/* video intr 1 	(0x1314)	*/
	int		pad18[1];
	volatile int	vint2_vec;	/* video intr 2 	(0x1315)	*/
	int		pad19[1];
	volatile int	odmaovrun_vec;	/* Odma overrun intr vec(0x1316)	*/
	int		pad20[1+19];
	volatile int	gef_intr_clr;	/* GEF intr clear 	(0x1320)	*/
	int		pad21[1+30];
	volatile int	fcg_error;	/* FCG error register	(0x1330)	*/
	int		pad22[1+(207*2)];
	volatile int	gfxlow;		/* fifo low water mark	(0x1400)	*/
	int		pad23[1];
	volatile int	gfxhigh;	/* fifo high water mark	(0x1401)	*/
	int		pad24[1];
	volatile int	gfxover;	/* fifo overflow mark	(0x1402)	*/
	int		pad25[1];
	volatile int	gfxwords;	/* fifo word count	(0x1403)	*/
	int		pad26[1];
	volatile int	gfxrptr;	/* fifo read ptr	(0x1404)	*/
	int		pad27[1];
	volatile int	gfxwptr;	/* fifo write ptr	(0x1405)	*/
	int		pad28[1+500];
	volatile int	jtag_cont;	/* jtag_cont[5:0]	(0x1500)	*/
	int		pad29[1];
	volatile int	jtag_td;	/* jtag_td[7:0]		(0x1501)	*/
	int		pad30[1];
	volatile int	jtag_tms;	/* jtag_tms[5:0]	(0x1502)	*/
	int		pad31[1];
	volatile int	jtag_misc;	/* bd_reg[7:0],tms_ge,tb_tms,ge_tdo,busy_l (0x1503) */
	int            pad32[2086392];
	volatile struct vc {
		volatile unsigned int value;
		unsigned int pad33;
	} vc[0x80000];
	volatile struct ubus {
		unsigned int pad34;
		unsigned short pad35;
		unsigned char pad36;
		volatile unsigned char value;
	} ubus[0x80000];
};

#endif /* _HOST_FCG_H_ */
