
/* 
 * this structure is used by GL and kernel to tell each other about
 * the use of linear address memory. 
 *
 * XXX - this file is used by both venice and vgx/vgx t texture managers even
 * though the two are slightly different. Perhaps it should be two files.
 */
#ifndef _ULAM_H_
#define _ULAM_H_

struct ulamslot { /* User LinearAddressMemory SLOT */

	/* These three fields are Kernel read/write, user read-only */
	int		state;	/* XXX this field and ref. stmts can be removed */
	int		taddr;  /* address in texture memory */
	int		macr;	/* imp mac;  */

	/* These fields are User read/write, kernel read-only */
	unsigned int*	vaddr;  /* virtual user address of texture; (SKYWR:NULL for fog)*/
	int		len;	/* length of texture in hardware; given in 32-bit words */

	/*  This field is for GL use only */
	void*		texdef;
};

#endif	/* _ULAM_H_ */
