#ifndef __SYS_VIDEOADDR_H__
#define __SYS_VIDEOADDR_H__

#ifdef __cplusplus
extern "C" {
#endif

/*
 * videoaddr.h
 *
 *	This module declares addresses for SGI standard video devices.
 *
 *
 * Copyright 1992, 1993 Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ident "$Revision: 1.3 $"

/* 
 * Video Splitter 2 (Multi-Channel-Option):
 *      physical VME addresses
 *
 * You can install up to three separate VS2's in a single VME bus, or 
 * install three VS2's to three separate VME buses (in the EVEREST 
 * configuration which supports multiple VME buses); in the latter case,
 * it doesn't matter whether or not you use the same physical address or
 * not.
 */

#define VIDEO_MP_VME_A24NPBASE    0xb2000000

/*
 * Top 8MB of A24 space reserved by IP5/7/9/13/15 RAM.
 */
#define VIDEO_MP_VME_A24NP_PHYS_MIN_ADDR    0x00800000
#define VIDEO_MP_VME_A24NP_PHYS_MAX_ADDR    0x00ffffff

#define VIDEO_VS2_A24_NP_BASE_PIPE0	0x00800000
#define VIDEO_VS2_A24_NP_BASE_PIPE1	0x00810000
#define VIDEO_VS2_A24_NP_BASE_PIPE2	0x00820000

#define VIDEO_VS2_SIZE			0x10000

#if defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS)


#ifdef _KERNEL
#else
#endif

#endif /* C || C++ */

#ifdef __cplusplus
}
#endif

#endif /* !__SYS_VIDEOADDR_H__ */
