#ifndef _WCHAR_H
#define _WCHAR_H
#ifdef __cplusplus
extern "C" {
#endif
#ident "$Revision: 1.11 $"
/*
*
* Copyright 1995, Silicon Graphics, Inc.
* All Rights Reserved.
*
* This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
* the contents of this file may not be disclosed to third parties, copied or
* duplicated in any form, in whole or in part, without the prior written
* permission of Silicon Graphics, Inc.
*
* RESTRICTED RIGHTS LEGEND:
* Use, duplication or disclosure by the Government is subject to restrictions
* as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
* and Computer Software clause at DFARS 252.227-7013, and/or in similar or
* successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
* rights reserved under the Copyright Laws of the United States.
*/
#include <sgidefs.h>
#include <standards.h>
/*
 * This is an XPG4 header
 */

#if !defined(_SIZE_T) && !defined(_SIZE_T_)
#define _SIZE_T
#if (_MIPS_SZLONG == 32)
typedef unsigned int	size_t;
#endif
#if (_MIPS_SZLONG == 64)
typedef unsigned long	size_t;
#endif
#endif

#ifndef _WCHAR_T
#define _WCHAR_T
#if (_MIPS_SZLONG == 32)
typedef long wchar_t;
#endif
#if (_MIPS_SZLONG == 64)
typedef __int32_t wchar_t;
#endif
#endif

#ifndef _WUCHAR_T
#   define _WUCHAR_T
#if (_MIPS_SZLONG == 32)
	typedef unsigned long	wuchar_t;
#endif
#if (_MIPS_SZLONG == 64)
	typedef __uint32_t	wuchar_t;
#endif
#endif

#ifndef _WINT_T
#   define _WINT_T
#if (_MIPS_SZLONG == 32)
	typedef long	wint_t;
#endif
#if (_MIPS_SZLONG == 64)
	typedef __int32_t wint_t;
#endif
#endif

#ifndef _WCTYPE_T
#   define _WCTYPE_T
#if (_MIPS_SZLONG == 32)
	typedef unsigned long	wctype_t;
#endif
#if (_MIPS_SZLONG == 64)
	typedef __uint32_t	wctype_t;
#endif
#endif

#ifndef _MBSTATE_T
#   define _MBSTATE_T
	typedef char	mbstate_t;
#endif

#ifndef NULL
#   define NULL	0L
#endif

#ifndef WEOF
#   define WEOF	(-1)
#endif

#include <stdio.h>	/* it requires FILE to be completed! */
#include <ctype.h>
#include <time.h>	/* for struct tm */

extern int	iswalnum(wint_t);
extern int	iswalpha(wint_t);
extern int	iswcntrl(wint_t);
extern int	iswdigit(wint_t);
extern int	iswgraph(wint_t);
extern int	iswlower(wint_t);
extern int	iswprint(wint_t);
extern int	iswpunct(wint_t);
extern int	iswspace(wint_t);
extern int	iswupper(wint_t);
extern int	iswxdigit(wint_t);
extern int	iswctype(wint_t, wctype_t);
extern wctype_t	wctype(const char *);
extern wint_t	towlower(wint_t);
extern wint_t	towupper(wint_t);

extern wint_t	fgetwc(FILE *);
extern wchar_t	*fgetws(wchar_t *, int, FILE *);
extern wint_t	fputwc(wint_t, FILE *);
extern int	fputws(const wchar_t *, FILE *);
extern wint_t	getwc(FILE *);
extern wint_t	getwchar(void);
extern wint_t	putwc(wint_t, FILE *);
extern wint_t	putwchar(wint_t);
extern wint_t	ungetwc(wint_t, FILE *);
#define getwchar()	getwc(stdin)
#define putwchar(x)	putwc((x), stdout)

extern wchar_t	*wcscat(wchar_t *, const wchar_t *);
extern wchar_t	*wcschr(const wchar_t *, wint_t);
extern int	wcscmp(const wchar_t *, const wchar_t *);
extern int	wcscoll(const wchar_t *, const wchar_t *);
extern size_t	wcsxfrm(wchar_t *, const wchar_t *, size_t);
extern wchar_t	*wcscpy(wchar_t *, const wchar_t *);
extern size_t	wcscspn(const wchar_t *, const wchar_t *);
extern size_t	wcslen(const wchar_t *);
extern wchar_t	*wcsncat(wchar_t *, const wchar_t *, size_t);
extern int	wcsncmp(const wchar_t *, const wchar_t *, size_t);
extern wchar_t	*wcsncpy(wchar_t *, const wchar_t *, size_t);
extern wchar_t	*wcspbrk(const wchar_t *, const wchar_t *);
extern wchar_t	*wcsrchr(const wchar_t *, wint_t);
extern size_t	wcsspn(const wchar_t *, const wchar_t *);
extern wchar_t	*wcstok(wchar_t *, const wchar_t *);
extern wchar_t	*wcsstr(const wchar_t *, const wchar_t *);
extern size_t	wcsftime(wchar_t *, size_t, const char *, const struct tm *);

extern int	wcwidth(wint_t);
extern int	wcswidth(const wchar_t *, size_t);
extern wchar_t	*wcswcs(const wchar_t *, const wchar_t *);

extern double	wcstod(const wchar_t *, wchar_t **);
extern long	wcstol(const wchar_t *, wchar_t **, int);
extern unsigned long	wcstoul(const wchar_t *, wchar_t **, int);

extern int __iswctype(wint_t, wctype_t);
extern wint_t	__trwctype(wint_t, wctype_t);

#define	_E1	0x00000100	/* phonogram (international use) */
#define	_E2	0x00000200	/* ideogram (international use) */
#define	_E3	0x00000400	/* English (international use) */
#define	_E4	0x00000800	/* number (international use) */
#define	_E5	0x00001000	/* special (international use) */
#define	_E6	0x00002000	/* other characters (international use) */
#define	_E7	0x00004000	/* reserved (international use) */
#define	_E8	0x00008000	/* reserved (international use) */

#if _SGIAPI
#define iscodeset0(c)	(!((c) & ~0xff))
#define iscodeset1(c)	(((c) >> 28) == 0x3)
#define iscodeset2(c)	(((c) >> 28) == 0x1)
#define iscodeset3(c)	(((c) >> 28) == 0x2)

extern int	iswascii(wint_t);
extern int	isphonogram(wint_t);
extern int	isideogram(wint_t);
extern int	isenglish(wint_t);
extern int	isnumber(wint_t);
extern int	isspecial(wint_t);
extern wchar_t	*wcstok_r(wchar_t *, const wchar_t *, wchar_t **);
#endif /* _SGIAPI */

#if _UNSAFE_WCTYPE
/*
 * Due to ANSI/XPG rules, macro arguments may be only evaluated once.
 * Standard macro definitions of iswprint et.al. require evaluation
 * of their argument twice. So, there are 3 options:
 * 1) no macros
 * 2) stick evaluated argument in a static
 * 3) provide 'unsafe' macros that evaluate the argument twice.
 *
 * Std SVR4 provides 2) - this is really bad for multi-threaded apps
 * as well as signal handlers etc..
 * We opt for 1 and 3 - for applications that explicitly need speed
 * and can guarantee that multiple evaluation is ok, the following are
 * provided.
 */
#define	iswalpha(c) ((c) > 255 ? __iswctype(c, _U | _L) \
			: ((__ctype + 1)[c] & (_U | _L)))
#define	iswupper(c) ((c) > 255 ? __iswctype(c, _U) \
			: ((__ctype + 1)[c] & _U))
#define	iswlower(c) ((c) > 255 ? __iswctype(c, _L) \
			: ((__ctype + 1)[c] & _L))
#define	iswdigit(c) ((c) > 255 ? __iswctype(c, _N) \
			: ((__ctype + 1)[c] & _N))
#define	iswxdigit(c) ((c) > 255 ? __iswctype(c, _X) \
			: ((__ctype + 1)[c] & _X))
#define	iswalnum(c) ((c) > 255 ? __iswctype(c, _U | _L | _N) \
			: ((__ctype + 1)[c] & (_U | _L | _N)))
#define	iswspace(c) ((c) > 255 ? __iswctype(c, _S) \
			: ((__ctype + 1)[c] & _S))
#define	iswpunct(c) ((c) > 255 ? __iswctype(c, _P) \
			: ((__ctype + 1)[c] & _P))
#define	iswprint(c) ((c) > 255 ? \
			__iswctype(c, _P|_U|_L|_N|_B|_E1|_E2|_E5|_E6) \
			: ((__ctype + 1)[c] & (_P | _U | _L | _N | _B)))
#define	iswgraph(c) ((c) > 255 ? \
			__iswctype(c, _P|_U|_L|_N|_E1|_E2|_E5|_E6) \
			: ((__ctype + 1)[c] & (_P | _U | _L | _N)))
#define	iswcntrl(c) ((c) > 255 ? __iswctype(c, _C) \
			: ((__ctype + 1)[c] & _C))
#define	iswascii(c)	(!((c) & ~0177))
#define	towupper(c) ((c) > 255 ? _trwctype(c, _L) : toupper(c))
#define	towlower(c) ((c) > 255 ? _trwctype(c, _U) : tolower(c))

#define	isphonogram(c)	((c) > 255 && __iswctype(c, _E1))
#define	isideogram(c)	((c) > 255 && __iswctype(c, _E2))
#define	isenglish(c)	((c) > 255 && __iswctype(c, _E3))
#define	isnumber(c)	((c) > 255 && __iswctype(c, _E4))
#define	isspecial(c)	((c) > 255 && __iswctype(c, _E5))
#endif /* _UNSAFE_WCTYPE */

#ifdef __cplusplus
}
#endif

#endif /*_WCHAR_H*/
